Download it now!
Bug 112135 - Provide alternative controls through context menu in function list of Customize dialog
Summary: Provide alternative controls through context menu in function list of Customi...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
6.0.0.0.alpha0+
Hardware: All All
: medium enhancement
Assignee: Sarper Akdemir
URL:
Whiteboard: target:7.0.0
Keywords: difficultyInteresting, easyHack, skillCpp, skillUI, topicUI
Depends on:
Blocks: Customise-Dialog
  Show dependency treegraph
 
Reported: 2017-08-31 08:18 UTC by Heiko Tietze
Modified: 2020-02-28 19:03 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Heiko Tietze 2017-08-31 08:18:25 UTC
Lists do allow interaction per context menu usually. So users may expect to also have the ability to modify (rename) and insert items via context menu, as well as add/remove.
Comment 1 Yousuf Philips (jay) (retired) 2017-09-24 14:19:53 UTC
(In reply to Heiko Tietze from comment #0)
> Lists do allow interaction per context menu usually.

I havent seen any lists in LO that provide a context menu, while i have seen lists that have right-click act no different to left-click (e.g. autocorrect dialog, exceptions tab). So what is 'usually' based on?
Comment 2 Heiko Tietze 2017-09-24 15:44:05 UTC
(In reply to Yousuf Philips (jay) from comment #1)
> So what is 'usually' based on?

Software in general. But I would object you 'not in LibreOffice' argument. Styles: yes, gallery: yes, navigator: yes... though the offered functions are not always what the user is looking for.
Comment 3 Yousuf Philips (jay) (retired) 2017-09-24 22:01:21 UTC
(In reply to Heiko Tietze from comment #2)
> Software in general.

Any particular software that i might have on my pc?

> But I would object you 'not in LibreOffice' argument.
> Styles: yes, gallery: yes, navigator: yes... though the offered functions
> are not always what the user is looking for.

Styles and navigator are tree controls and gallery is icon display control. Them having a scrollbar on the side of the control doesnt make them a listbox.
Comment 4 QA Administrators 2018-10-25 03:02:48 UTC Comment hidden (obsolete)
Comment 5 Roman Kuznetsov 2018-10-25 07:05:42 UTC
Change to Enhancement

still missed in

Version: 6.2.0.0.alpha0+
Build ID: cec31fdedd7c94f4ebf903a66456a75867db22b0
CPU threads: 4; OS: Windows 6.1; UI render: default; VCL: win; 
TinderBox: Win-x86@42, Branch:master, Time: 2018-10-21_22:54:44
Locale: ru-RU (ru_RU); Calc: threaded

still need in future version ;-)
Comment 6 Muhammet Kara 2020-02-04 20:49:30 UTC
Let's make this an easyHack.

What to do?
-----------

Add context (right click) menu support to the Functions and Contents boxes of the customize dialog's Menu, Context Menu, and Menu tabs.

Probable context menu items for the Functions (left) list:
- Add

Probable context menu items for the Contents (right) list:
- Remove
- Rename


How? (Code pointers)
--------------------
Take CommandHdl from the fpicker/source/office/fileview.cxx as an example, and see how it is connected to mxTreeView with the connect_popup_menu() call, and how it is declared, and defined in the same file. You will also need to create a tiny ui file just like the one used there (svtools/uiconfig/ui/fileviewmenu.ui).

Source file for the menu and context menu tabs: cui/source/customize/SvxMenuConfigPage.cxx

Source file for the toolbar tab: cui/source/customize/SvxToolbarConfigPage.cxx

Right listbox (assigned commands): m_xContentsListBox
Left listbox (available functions): m_xFunctions
Comment 7 sdc.blanco 2020-02-06 15:05:33 UTC
(In reply to Muhammet Kara from comment #6)
> Let's make this an easyHack.
Maybe bug #114557 is relevant here (or maybe your proposal has already taken this into account). (Might be appropriate to "grey out" "rename" for these cases -- to avoid "confusion".)
Comment 8 Commit Notification 2020-02-28 17:34:36 UTC
Sarper Akdemir committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/d54202ff690e4e97e018461cc6dc3dfadd36a702

tdf#112135: Provide controls through context menu in lists of Customize dialog

It will be available in 7.0.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 9 Muhammet Kara 2020-02-28 17:35:44 UTC
(In reply to sdc.blanco from comment #7)
> (In reply to Muhammet Kara from comment #6)
> > Let's make this an easyHack.
> Maybe bug #114557 is relevant here (or maybe your proposal has already taken
> this into account). (Might be appropriate to "grey out" "rename" for these
> cases -- to avoid "confusion".)

The solution reuses the implementation of the current buttons. So no need to do anything special here. When the other bug is fixed, this will also be fixed.